package ru.landgrafhomyak.db.skeleton1.api.errors

import kotlinx.coroutines.CopyableThrowable
import kotlinx.coroutines.ExperimentalCoroutinesApi
import ru.landgrafhomyak.db.skeleton1.api.ReflectionApi

@ReflectionApi
@OptIn(ExperimentalCoroutinesApi::class)
public class AccessWhileInitializationException : IllegalStateException, CopyableThrowable<AccessWhileInitializationException> {
	public val `object`: Any
	public val member: Any

	public constructor(`object`: Any, member: Any) : super() {
		this.`object` = `object`
		this.member = member
	}

	public constructor(`object`: Any, member: Any, message: String) : super(message) {
		this.`object` = `object`
		this.member = member
	}

	public constructor(`object`: Any, member: Any, message: String, cause: Throwable) : super(message, cause) {
		this.`object` = `object`
		this.member = member
	}

	public constructor(`object`: Any, member: Any, cause: Throwable) : super(cause) {
		this.`object` = `object`
		this.member = member
	}

	public constructor(
		`object`: Any, member: Any,
		message: String?,
		cause: Throwable?,
		@Suppress("unused", "LocalVariableName") _marker: Unit
	) : super(message, cause) {
		this.`object` = `object`
		this.member = member
	}


	override fun createCopy(): AccessWhileInitializationException? {
		return AccessWhileInitializationException(
			`object` = this.`object`,
			member = this.member,
			message = this.message,
			cause = this.cause,
			_marker = Unit
		)
	}
}